#include "cx.h"
// #include <stdio.h>
// #include <stdlib.h>
#include <string.h>

// OUTPUT ****************************************************************

void operator<<(char*& s, const CX& c) //
{
  char *sx, *sy, *f = NULL;
  sx << c.x;
  sy << c.y;
  switch (RE_IO::output()) {
    case F_pari:   f = "(%s+I*%s)"; break;
    case F_long:   f = " %s %s";    break;
    case F_medium: f = "%s;%s";     break;
    case F_short:  f = "(%s;%s)";   break;
  }
  s = (char*)malloc(10+5+strlen(sx)+strlen(sy));
  sprintf(s, f, sx,sy);
  free(sx); free(sy);
}

// INPUT  ****************************************************************

static void
digitlen(const char *s)
{
  if ( *s == '-' ) s++;
  size_t len = strspn(s, ".0123456789") - strspn(s, ".0");
  if ( len != strspn(s + strspn(s,".0"), "0123456789") ) len--;
  if ( long(len) > cdigitprec()) setcdigitprec(len);
}
void operator<<(CX& c, const char* buffer) //
{
  char *b = (char*) malloc(1+strlen(buffer));
#if defined(mplib_pari) && defined(__complex__)
  c = cgetg(3,t_COMPLEX);
#endif
  sscanf(buffer, "%s", b);     digitlen(b);
#if defined(mplib_pari) && defined(__complex__)
  ((RE*)c)+1 << b;
#else
  c.x << b;
#endif
  sscanf(buffer, "%*s %s", b); digitlen(b);
#if defined(mplib_pari) && defined(__complex__)
  ((RE*)c)+2 << b;
#else
  c.y << b;
#endif
  free(b);
}

// ****************************************************************

#if defined(mplib_pari) && defined(__complex__)
/* Ceci est aussi dfini dans cx-pr.c */
static GEN
grealpart(const GEN x) {
  switch(typ(x)) {
    case t_INT: case t_REAL: case t_FRAC: case t_FRACN: return x;
    case t_COMPLEX:                                     return ((GEN*)x)[1];
    default:                   err(typeer,"grealpart"); return NULL;
  }
}
static GEN
gimagpart(const GEN x) {
  switch(typ(x)) {
    case t_INT: case t_REAL: case t_FRAC: case t_FRACN: return gzero;
    case t_COMPLEX:                                     return ((GEN*)x)[2];
    default:                   err(typeer,"gimagpart"); return NULL;
  }
}
#endif

void
ctodbl(double& cx, double& cy, const CX& c)
{
#if   defined(mplib_pari) && defined(__complex__)
  cx << grealpart(c));
  cy << gimagpart(c));
#else
  cx << c.x;
  cy << c.y;
#endif
}

#if 0

#ifdef mplib_pari               /* proto */
#ifdef __complex__
void
ctogen(GEN& g, const CX& c) { g = c; }
void
cfromgen(CX& c, const GEN g) { c = g; }

#else
void
ctogen(GEN& g, const CX& c) //
{
  g = cgetg(3,t_COMPLEX);
  ((GEN*)g)[1] = c.x.value();
  ((GEN*)g)[2] = c.y.value();
}

void
cfromgen(CX& c, const GEN g) //
{
  c = CX( grealpart(g), gimagpart(g) );
}
#endif

#endif

#endif                          /* proto */
