#ifndef RE__H
#define RE__H

#include <RR.h>

#error BUG

class RE : public RR
{
  RE(RR a)          : RR(a) { }
public:
  RE(int a = 0)     : RR(a) { }
  RE(long a)        : RR(a) { }
  RE(float a)       : RR(a) { }
  RE(double a)      : RR(a) { }
  void operator =( const RE& a ) { this->RR::operator=(a); }
  // Fundamental comparison operators
  //RR friend bool operator ==( const RE& a, const RE& b );
  //RR friend bool operator <=( const RE& a, const RE& b );
  //RR friend long IsZero( const RE& a);
  //RR friend long IsOne ( const RE& a);
  // Fundamental arithmetic operators
  friend RE operator -( const RE& a );
  friend RE inv  ( const RE&  a);
  friend RE sqrt ( const RE&  a);
  RE& operator +=( const RE& a );
  RE& operator *=( const RE& a );
  RE& operator -=( const RE& a ) { *this += -a; return *this; }
  RE& operator /=( const RE& a ) { *this *= inv(a); return *this; }
  long log2() const; // returns the precision of a ``0''
  // Fundamental output functions
  friend void operator <<( double& z, const RE& a );
  friend void operator <<( RE& z, const char* a );
  friend void operator <<( char*& s, const RE& r );
};

// Fundamental arithmetic operators
inline RE operator -( const RE& a ) { return RE(operator-(a)); }
inline RE inv  ( const RE&  a)      { return RE(inv      (a)); }
inline RE sqrt ( const RE&  a)      { return RE(sqrt     (a)); }
inline RE& RE::operator +=( const RE& a ) { add(*this,*this,a); return *this; }
inline RE& RE::operator *=( const RE& a ) { mul(*this,*this,a); return *this; }
inline long RE::log2() const { return 1 - e - NumBits(x); }
// Fundamental output functions
inline void operator <<( double& z, const RE& a ) { z << RR(a); }
inline void operator <<( RE& z, const char* a ) { z = RR(INIT_VAL,a); }
// [re-io.c] void operator <<( char*& s, const RE& r );

// -------- Definitions from fundamental methods --------
// Standard arithmetic operators
inline RE operator + (const RE& a, const RE& b) {RE r = a;r += b; return r;}
inline RE operator - (const RE& a, const RE& b) {RE r = a;r -= b; return r;}
inline RE operator * (const RE& a, const RE& b) {RE r = a;r *= b; return r;}
inline RE operator / (const RE& a, const RE& b) {RE r = a;r /= b; return r;}
// Standard arithmetic operators (as functions)
//RR inline void add(RE& z, const RE& a, const RE& b) { z = a + b; }
//RR inline void sub(RE& z, const RE& a, const RE& b) { z = a - b; }
//RR inline void mul(RE& z, const RE& a, const RE& b) { z = a * b; }
// Other operators
inline RE sqr ( const RE& a ) { return a * a; }
//RR inline bool operator !=( const RE& a, const RE& b ) { return !(a == b); }

#endif
