#ifndef RE__H
#define RE__H

#include <RR.h>

class RE : public RR
{
public:
  RE(RR a)          : RR(a) { }
  RE(int a = 0)     : RR(a) { }
  RE(long a)        : RR(a) { }
  RE(float a)       : RR(a) { }
  RE(double a)      : RR(a) { }
  RE(const char *a) : RR(INIT_VAL,a) { }
  operator double (void) const;
  operator char* (void) const;
  // Precision
  friend double log2 (const RE& a);    // log en base 2
  friend long precision (const RE& a); // prcision en bit
};

inline RE::operator double (void) const { double z; z << RR(*this); return z; }
// [re-io.c] RE::operator char* (void) const;
inline RE sqr ( const RE& a ) { RE res; ::sqr(res, a);     return res; }
// Precision
inline double log2 (const RE& a) { return IsZero(a)?mInf:a.e+NumBits(a.x)-1; }
inline long precision (const RE& a) { return RR::precision(); }

#endif
